# APC

> Advanced programming in C. Questions done in classroom.

## Array

- [Check float/double values by casting into char and then checking their values](./float-double.c)
- [2D array-pointers in detail](./arrayPointer.c)
- [Pascal's Triangle](./pascal-triangle.c)
- [kth row of Pascal's Triangle](./kthRow-pascal.c)

## Linked List

- [Hare tortoise methodology of traversing a linked list](./hareTortoiseLinkedList.c)
- [Reversing a linked list (Iterative and recursive solution)](./reversingLinkedList.c)
- [Swapping alternate nodes of linked list (Iterative and recursive solution)](./evenSwapLL.c)
- [Merge two sorted Linked Lists](./mergeSortedLL.c)
- [Check if a Linked List is palindromic or not](./palindromeLinkedList.c)
- [Remove Nth node from the end of a linked list](./removeNthNodeFromEnd.c)
- [Partition Of linked list(Interview Bit)](./partitionLL.c)
- [Rotate linked list(Interview Bit)](./rotateLL.c)
- [Reorder linked list(Interview Bit)](./reorderLL.c)
- [Insertion Sort linked list(Interview Bit)](./insertionSortLL.c)
- [Add 2 numbers linked list(Interview Bit)](./addTwoNumbersLL.c)
- [Remove duplicate value from linked list(Interview Bit)](./removeDuplicatesSortedLL.c)

## Binary Search

- [Binary Search Recursive and Iteration](./binarySearch.c)
- [Upper Bound and Lower Bound with binary search](./lowerUpperBound.c)
- [Square Root by binary search(InterviewBit)](./squareRoot.c)
- [Allocate Books Google Interview Question(InterviewBit)](./allocateBooks.c)
- [Painter Problem(Interview Bit)](./painterProblem.c)
- [Power function using binary search(Interview Bit)](./powerBinarySearch.c)

## Strings

- [Z value array Algorithm](./zValueArray.c)
- [Self implementation of strstr(Interview Bit)](./strstr.c)
- [Longest Palindromic String (Dynamic Solution 2D matrix)](./longestPalindromicString.c)
- [Count and Say (Interview Bit)](./countAndSay.c)
- [Version number comparison (Interview Bit)](./versionNumber.cpp)

## Stack

- [Infix to Postfix (Interview Bit)](./infixToPostfix.c)
- [Trap Water (Interview Bit)](./trappingWater.c)
- [Equal Stacks (Hackerrank)](./EqualStacks.c)
- [Largest area in a histogram (Interview Bit)](./largestRectangleInHistogram.c)

## Binary Tree

- [Top view of Binary Tree (Important Question)](./topView.cpp)
- [Morison Inorder Traversal](./morisonInorderTraversal.cpp)
- [Morison Inorder Traversal](./morisonPreorderTraversal.cpp)
- [Diameter of Binary tree O(N) solution](./diameterOfBT.cpp)
- [Minimum depth of Binary tree (Interview Bit)](./minDepthBT.cpp)
- [Equal trees (Interview Bit)](./EqualTrees.cpp)
- [Mirror image of a binary tree](./mirrorImageOfBT.cpp)
- [Path with maximum sum from root to leaf](./maximumSumBT.cpp)
- [Construct BT from preorder and inorder arrays(Interview Bit)](./constructTreeInorderPreorder.cpp)
- [Construct BT from postorder and inorder arrays(Interview Bit)](./constructTreeInorderPostorder.cpp)
- [Find given sum from root to leaf of a Binary Tree(Interview Bit)](./sumFromRootToLeaf.cpp)

## Binary Search Tree

- [Valid Binary Search Tree from preorder](./validBST.c)
- [Create a Binary Search Tree from a sorted array](./bstFromSortedArray.c)
- [Find Lowest common ancestor](./lowestCommonAncestor.c)
- [AVL Tree (Balancing binary search tree)](./AVLtree.c)

## Tree

- [Trie Tree for storing strings (Prefix Suffix)](./trieTree.c)

## Others

- [Quick Sort lib with void pointers and comparators](./Qsort_lib_comp.c)
- [Reversing bits of a number](./reversingBits.c)
